from datetime import datetime, date
import json


class PeerTransferRequest(object):

    def __init__(self, json_response):
        self.json_response = json_response

    def __str__(self):
        return json.dumps(self.json_response, default=self.json_serial)

    @staticmethod
    def json_serial(o):
        if isinstance(o, datetime) or isinstance(o, date):
            return o.__str__()

    @property
    def token(self):
        return self.json_response.get('token', None)

    @property
    def amount(self):
        return self.json_response.get('amount', None)

    @property
    def tags(self):
        return self.json_response.get('tags', None)

    @property
    def memo(self):
        return self.json_response.get('memo', None)

    @property
    def sender_user_token(self):
        return self.json_response.get('sender_user_token', None)

    @property
    def recipient_user_token(self):
        return self.json_response.get('recipient_user_token', None)

    @property
    def sender_business_token(self):
        return self.json_response.get('sender_business_token', None)

    @property
    def recipient_business_token(self):
        return self.json_response.get('recipient_business_token', None)

    @property
    def currency_code(self):
        return self.json_response.get('currency_code', None)

    def __repr__(self):
        return '<Marqeta.response_models.peer_transfer_request.PeerTransferRequest>' + self.__str__()
